<template>
  <div>
    <h2 id="page-heading" data-cy="EncuestaHeading">
      <span v-text="$t('gatewayApp.manillaEncuesta.home.title')" id="encuesta-heading">Encuestas</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.manillaEncuesta.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'EncuestaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-encuesta"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.manillaEncuesta.home.createLabel')"> Create a new Encuesta </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && encuestas && encuestas.length === 0">
      <span v-text="$t('gatewayApp.manillaEncuesta.home.notFound')">No encuestas found</span>
    </div>
    <div class="table-responsive" v-if="encuestas && encuestas.length > 0">
      <table class="table table-striped" aria-describedby="encuestas">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('fecha')">
              <span v-text="$t('gatewayApp.manillaEncuesta.fecha')">Fecha</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'fecha'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('debilidad')">
              <span v-text="$t('gatewayApp.manillaEncuesta.debilidad')">Debilidad</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'debilidad'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('cefalea')">
              <span v-text="$t('gatewayApp.manillaEncuesta.cefalea')">Cefalea</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'cefalea'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('calambres')">
              <span v-text="$t('gatewayApp.manillaEncuesta.calambres')">Calambres</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'calambres'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('nauseas')">
              <span v-text="$t('gatewayApp.manillaEncuesta.nauseas')">Nauseas</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'nauseas'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('vomito')">
              <span v-text="$t('gatewayApp.manillaEncuesta.vomito')">Vomito</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'vomito'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('mareo')">
              <span v-text="$t('gatewayApp.manillaEncuesta.mareo')">Mareo</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'mareo'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('ninguna')">
              <span v-text="$t('gatewayApp.manillaEncuesta.ninguna')">Ninguna</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'ninguna'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('user.login')">
              <span v-text="$t('gatewayApp.manillaEncuesta.user')">User</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'user.login'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="encuesta in encuestas" :key="encuesta.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'EncuestaView', params: { encuestaId: encuesta.id } }">{{ encuesta.id }}</router-link>
            </td>
            <td>{{ encuesta.fecha ? $d(Date.parse(encuesta.fecha), 'short') : '' }}</td>
            <td>{{ encuesta.debilidad }}</td>
            <td>{{ encuesta.cefalea }}</td>
            <td>{{ encuesta.calambres }}</td>
            <td>{{ encuesta.nauseas }}</td>
            <td>{{ encuesta.vomito }}</td>
            <td>{{ encuesta.mareo }}</td>
            <td>{{ encuesta.ninguna }}</td>
            <td>
              {{ encuesta.user ? encuesta.user.login : '' }}
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'EncuestaView', params: { encuestaId: encuesta.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'EncuestaEdit', params: { encuestaId: encuesta.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(encuesta)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.manillaEncuesta.delete.question" data-cy="encuestaDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-encuesta-heading" v-text="$t('gatewayApp.manillaEncuesta.delete.question', { id: removeId })">
          Are you sure you want to delete this Encuesta?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-encuesta"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeEncuesta()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./encuesta.component.ts"></script>
